from django.shortcuts import render
# Create your views here.
from django.shortcuts import render
from django.shortcuts import render,redirect
from rest_framework.response import Response
from rest_framework import status
from rest_framework.views import APIView
from django.utils.decorators import method_decorator
from django.contrib.auth.decorators import user_passes_test
import operator
from functools import reduce
from django.db.models import Q

from clmainApp.utils import getClinicId,getBranchId
from clmainApp.models import *
from datetime import datetime,date,timedelta
from django.urls import reverse
from .serializers import *
from .models  import *

# Create your views here.
class CurrentPatientVisitsApi(APIView):
    @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.view_currentvisits'), login_url='/auth/login/'))
    def get(self,request):
        user = request.user
        if not (user.user_category == "2DR" or user.is_superuser) : return redirect('clauthApp:home')
        return render(request,"Branch/brvisitApp/current_visits.html",{'activePage':'CurrentPatientVisits'})

class ActivePatientVisitsApi(APIView):#Today visits  == current visits # for doctor 
    # @method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.add_lead_visit'), login_url='/auth/login/'))
    def get(self,request,branch_id):
        user = request.user
        if user.is_superuser : visits =PatientVisit.objects.filter(visit_status__in=["1I","2W"],visit_branch_id=branch_id).order_by("visit_status")
        else : visits =PatientVisit.objects.filter(visit_status__in=["1I","2W"],visit_branch_id=branch_id,doctor_id=request.user.id).order_by("visit_status")
        visits_serializer= PatientVisitDrSerializer(visits,many=True)
        #data = {"active_visits":visits_serializer.data}
        return Response(visits_serializer.data,status=status.HTTP_200_OK)
    
class PatientVisitApi(APIView):
    def get_object(self,pk):
        try:
            return PatientVisit.objects.get(pk=pk)
        except PatientVisit.DoesNotExist:
            return None    
    
    @method_decorator(user_passes_test(lambda u: u.has_perm('screen.view_PatientVisit'), login_url='/auth/login/'))        
    def get(self,request,pk): 
        patient_visitObj=self.get_object(pk)
        if patient_visitObj :
            #return render(request,"mainApp/patient_visit.html",{"patient_visit":patient_visitObj,'activePage':'PatientVisits'})
            serializeobj= PatientVisitSerializer(patient_visitObj)
            return Response(serializeobj.data,status=status.HTTP_200_OK)
        else : return Response(status=status.HTTP_404_NOT_FOUND)
    
    #@method_decorator(user_passes_test(lambda u: u.has_perm('BrManagement.change_group'), login_url='/auth/login/'))
    def post(self,request,pk):
        obj=self.get_object(pk)
        data=request.data
        if not data["sessions_max"] : obj.sessions_max = None
        else : obj.sessions_max = data["sessions_max"]
        if not data["notes_for_rcptn"] : obj.notes_for_rcptn = None
        else :obj.notes_for_rcptn = data["notes_for_rcptn"]
        if not data["sessions_min"] : Response("Error in Minimum sessions",status=status.HTTP_400_BAD_REQUEST)
        if not data["recommended_session"] : Response("Error in Recommended session",status=status.HTTP_400_BAD_REQUEST)
        try:
            obj.recommended_session_id = data["recommended_session"]
            obj.sessions_min = data["sessions_min"]
            obj.save()
            return Response(status=status.HTTP_200_OK)
        except Exception as err:
            Response("{}".format(str(err)),status=status.HTTP_400_BAD_REQUEST)

    @method_decorator(user_passes_test(lambda u: u.has_perm('screen.edit_PatientVisit'), login_url='/auth/login/'))
    def put(self,request,pk):
        obj=self.get_object(pk)
        newStatus = request.data.get("newStatus")
        current_visit_notes_dr = request.data.get("current_visit_notes_dr")
        next_visit_notes_dr = request.data.get("next_visit_notes_dr")
        #notes_for_rcptn = request.data.get("notes_for_rcptn")
        if newStatus == "discount_and_note" :
            #doctor_discount = request.data.get("doctor_discount")
            next_consult = request.data.get("next_consult")
            ptnt = Patient.objects.get(id=obj.patient.id)
            if next_consult or int(next_consult) >= 0 :
                #obj.next_consult_days = next_consult
                todayObj = date.today()
                next_consult_day = todayObj+timedelta(days=int(next_consult))
                if next_consult_day > ptnt.next_consult :
                    ptnt.next_consult = next_consult_day
                    ptnt.save()
            # if doctor_discount and int(doctor_discount) > 0 : 
            #     obj.doctor_discount = doctor_discount
            #     ptnt.debt =ptnt.debt  - int(doctor_discount)
            if doctor_notes : obj.doctor_notes = doctor_notes
            ptnt.save()
            obj.save()
            return Response(status=status.HTTP_200_OK)
        if newStatus == "next_and_note" :
            next_consult = request.data.get("next_consult")
            if next_consult :
                ptnt = Patient.objects.get(id=obj.patient.id)
                todayObj = date.today()
                next_consult_date = todayObj+timedelta(days=int(next_consult))
                obj.next_consult_days = next_consult
                obj.next_consult_date = next_consult_date
                if next_consult and int(next_consult) > 0 :
                    ptnt.next_consult = next_consult_date
                    ptnt.save()
            if current_visit_notes_dr : obj.current_visit_notes_dr = current_visit_notes_dr
            if next_visit_notes_dr : obj.next_visit_notes_dr = next_visit_notes_dr
            #if notes_for_rcptn : obj.notes_for_rcptn = notes_for_rcptn
            obj.save()
            return Response(status=status.HTTP_200_OK)
        
        #else : return Response(serializedObj.errors,status=status.HTTP_400_BAD_REQUEST)          

    @method_decorator(user_passes_test(lambda u: u.has_perm('screen.delete_PatientVisit'), login_url='/auth/login/'))
    def delete(self,request,pk):
        obj=self.get_object(pk)
        if obj :
            try:
                obj.delete()
                return Response(status=status.HTTP_204_NO_CONTENT)
            except Exception as err_msg: 
                    return Response(data ="{}".format(str(err_msg)),status=status.HTTP_405_METHOD_NOT_ALLOWED)
        else : return Response(status=status.HTTP_404_NOT_FOUND)